using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Float
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private C1.Win.C1Chart.C1Chart c1Chart1;
		private System.Windows.Forms.CheckBox chkESeries3;
		private System.Windows.Forms.CheckBox chkESeries1;
		private System.Windows.Forms.CheckBox chkESeries2;
		private System.Windows.Forms.CheckBox chkESeries0;
		private System.Windows.Forms.CheckBox chkHSeries3;
		private System.Windows.Forms.CheckBox chkHSeries1;
		private System.Windows.Forms.CheckBox chkHSeries2;
		private System.Windows.Forms.CheckBox chkHSeries0;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuFileExit;
		private System.Windows.Forms.MenuItem menuHelpAbout;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		void setupChart()
		{
			// setup chart style
			c1Chart1.Style.BackColor = Color.LightBlue;
			c1Chart1.Style.Border.BorderStyle = C1.Win.C1Chart.BorderStyleEnum.Fillet;
			c1Chart1.Style.Border.Thickness = 1;

			// setup header
			c1Chart1.Header.Style.BackColor = Color.LightYellow;
			c1Chart1.Header.Style.Border.BorderStyle = C1.Win.C1Chart.BorderStyleEnum.RaisedBevel;
			c1Chart1.Header.Style.Border.Thickness = 1;
			c1Chart1.Header.Style.Font = new Font( "Arial", 10);
			c1Chart1.Header.Text = "Use the Check Boxes to the Left to Hide or Exclude a Series";

			// setup chart area
			c1Chart1.ChartArea.Style.BackColor = Color.PaleGreen;
			c1Chart1.ChartArea.Style.Border.BorderStyle = C1.Win.C1Chart.BorderStyleEnum.RaisedBevel;
			c1Chart1.ChartArea.Style.Border.Thickness = 4;

			// setup legend
			//c1Chart1.ChartArea.Style.BackColor = Color.PaleGreen;
			c1Chart1.Legend.Style.Border.BorderStyle = C1.Win.C1Chart.BorderStyleEnum.Groove;
			c1Chart1.Legend.Style.Border.Thickness = 2;
			c1Chart1.Legend.Style.Border.Color = Color.LightBlue;
			c1Chart1.Legend.Style.HorizontalAlignment = C1.Win.C1Chart.AlignHorzEnum.Center;
			c1Chart1.Legend.Style.Font = new Font( "Tahoma", 10);
			c1Chart1.Legend.Text = "Series";
			c1Chart1.Legend.Visible = true;

			// setup axes
			c1Chart1.ChartArea.AxisY.Min = 0;
			c1Chart1.ChartArea.AxisY.Max = 100;

			c1Chart1.ChartArea.AxisX.GridMajor.Color = Color.Black;
			c1Chart1.ChartArea.AxisY.GridMajor.Color = Color.Black;

			c1Chart1.ChartArea.AxisX.GridMajor.Visible = true;
			c1Chart1.ChartArea.AxisY.GridMajor.Visible = true;

			// setup chart type
			c1Chart1.ChartGroups[0].ChartType = C1.Win.C1Chart.Chart2DTypeEnum.Bar;
			c1Chart1.ChartGroups[0].Stacked  = true;

			// setup series appearence
			c1Chart1.ChartGroups[0].ChartData[0].LineStyle.Color = Color.Red;
			c1Chart1.ChartGroups[0].ChartData[1].LineStyle.Color = Color.Tan;
			c1Chart1.ChartGroups[0].ChartData[2].LineStyle.Color = Color.Green;
			c1Chart1.ChartGroups[0].ChartData[3].LineStyle.Color = Color.MediumTurquoise;
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuFileExit = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuHelpAbout = new System.Windows.Forms.MenuItem();
			this.panel2 = new System.Windows.Forms.Panel();
			this.c1Chart1 = new C1.Win.C1Chart.C1Chart();
			this.panel3 = new System.Windows.Forms.Panel();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.chkESeries3 = new System.Windows.Forms.CheckBox();
			this.chkESeries1 = new System.Windows.Forms.CheckBox();
			this.chkESeries2 = new System.Windows.Forms.CheckBox();
			this.chkESeries0 = new System.Windows.Forms.CheckBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.chkHSeries3 = new System.Windows.Forms.CheckBox();
			this.chkHSeries1 = new System.Windows.Forms.CheckBox();
			this.chkHSeries2 = new System.Windows.Forms.CheckBox();
			this.chkHSeries0 = new System.Windows.Forms.CheckBox();
			this.panel2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.c1Chart1)).BeginInit();
			this.panel3.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																							this.menuItem1,
																																							this.menuItem3});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																							this.menuFileExit});
			this.menuItem1.Text = "&File";
			// 
			// menuFileExit
			// 
			this.menuFileExit.Index = 0;
			this.menuFileExit.Text = "E&xit";
			this.menuFileExit.Click += new System.EventHandler(this.menuFileExit_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																							this.menuHelpAbout});
			this.menuItem3.Text = "&Help";
			// 
			// menuHelpAbout
			// 
			this.menuHelpAbout.Index = 0;
			this.menuHelpAbout.Text = "&About";
			this.menuHelpAbout.Click += new System.EventHandler(this.menuHelpAbout_Click);
			// 
			// panel2
			// 
			this.panel2.Controls.AddRange(new System.Windows.Forms.Control[] {
																																				 this.c1Chart1,
																																				 this.panel3});
			this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(592, 403);
			this.panel2.TabIndex = 4;
			// 
			// c1Chart1
			// 
			this.c1Chart1.BackColor = System.Drawing.Color.LightBlue;
			this.c1Chart1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.c1Chart1.Location = new System.Drawing.Point(104, 0);
			this.c1Chart1.Name = "c1Chart1";
			this.c1Chart1.PropBag = "<?xml version=\"1.0\"?><Chart2DPropBag Version=\"\"><StyleCollection><NamedStyle><Par" +
				"entName>Area</ParentName><StyleData>Border=None,Control,1;</StyleData><Name>Plot" +
				"Area</Name></NamedStyle><NamedStyle><ParentName>Legend.default</ParentName><Styl" +
				"eData /><Name>Legend</Name></NamedStyle><NamedStyle><ParentName>Control</ParentN" +
				"ame><StyleData>Border=None,Control,1;</StyleData><Name>Footer</Name></NamedStyle" +
				"><NamedStyle><ParentName>Area.default</ParentName><StyleData /><Name>Area</Name>" +
				"</NamedStyle><NamedStyle><ParentName>Control.default</ParentName><StyleData /><N" +
				"ame>Control</Name></NamedStyle><NamedStyle><ParentName>Area</ParentName><StyleDa" +
				"ta>Rotation=Rotate0;Border=None,Control,1;AlignHorz=Center;BackColor=Transparent" +
				";AlignVert=Bottom;</StyleData><Name>AxisX</Name></NamedStyle><NamedStyle><Parent" +
				"Name>Area</ParentName><StyleData>Rotation=Rotate270;Border=None,Control,1;AlignH" +
				"orz=Near;BackColor=Transparent;AlignVert=Center;</StyleData><Name>AxisY</Name></" +
				"NamedStyle><NamedStyle><ParentName>LabelStyleDefault.default</ParentName><StyleD" +
				"ata /><Name>LabelStyleDefault</Name></NamedStyle><NamedStyle><ParentName>Control" +
				"</ParentName><StyleData>Border=None,Black,1;Wrap=False;AlignVert=Top;</StyleData" +
				"><Name>Legend.default</Name></NamedStyle><NamedStyle><ParentName>Control</Parent" +
				"Name><StyleData>Border=None,Control,1;BackColor=Transparent;</StyleData><Name>La" +
				"belStyleDefault.default</Name></NamedStyle><NamedStyle><ParentName>Control</Pare" +
				"ntName><StyleData>Border=None,Control,1;</StyleData><Name>Header</Name></NamedSt" +
				"yle><NamedStyle><ParentName /><StyleData>ForeColor=ControlText;Border=None,Contr" +
				"ol,1;BackColor=Control;</StyleData><Name>Control.default</Name></NamedStyle><Nam" +
				"edStyle><ParentName>Area</ParentName><StyleData>Rotation=Rotate90;Border=None,Tr" +
				"ansparent,1;AlignHorz=Far;BackColor=Transparent;AlignVert=Center;</StyleData><Na" +
				"me>AxisY2</Name></NamedStyle><NamedStyle><ParentName>Control</ParentName><StyleD" +
				"ata>Border=None,Control,1;AlignVert=Top;</StyleData><Name>Area.default</Name></N" +
				"amedStyle></StyleCollection><Axes><Axis Max=\"5\" Min=\"1\" UnitMajor=\"1\" UnitMinor=" +
				"\"0.5\" AutoMajor=\"True\" AutoMinor=\"True\" AutoMax=\"True\" AutoMin=\"True\" _onTop=\"0\"" +
				" Compass=\"South\"><GridMajor AutoSpace=\"True\" Thickness=\"1\" Color=\"LightGray\" Pat" +
				"tern=\"Dash\" /><GridMinor AutoSpace=\"True\" Thickness=\"1\" Color=\"LightGray\" Patter" +
				"n=\"Dash\" /><Text /></Axis><Axis Max=\"25\" Min=\"8\" UnitMajor=\"2\" UnitMinor=\"1\" Aut" +
				"oMajor=\"True\" AutoMinor=\"True\" AutoMax=\"True\" AutoMin=\"True\" _onTop=\"0\" Compass=" +
				"\"West\"><GridMajor AutoSpace=\"True\" Thickness=\"1\" Color=\"LightGray\" Pattern=\"Dash" +
				"\" /><GridMinor AutoSpace=\"True\" Thickness=\"1\" Color=\"LightGray\" Pattern=\"Dash\" /" +
				"><Text /></Axis><Axis Max=\"0\" Min=\"0\" UnitMajor=\"0\" UnitMinor=\"0\" AutoMajor=\"Tru" +
				"e\" AutoMinor=\"True\" AutoMax=\"True\" AutoMin=\"True\" _onTop=\"0\" Compass=\"East\"><Gri" +
				"dMajor AutoSpace=\"True\" Thickness=\"1\" Color=\"LightGray\" Pattern=\"Dash\" /><GridMi" +
				"nor AutoSpace=\"True\" Thickness=\"1\" Color=\"LightGray\" Pattern=\"Dash\" /><Text /></" +
				"Axis></Axes><Header Compass=\"North\"><Text /></Header><Footer Compass=\"South\"><Te" +
				"xt /></Footer><Legend Compass=\"East\" Visible=\"False\"><Text /></Legend><ChartArea" +
				" /><ChartGroupsCollection><ChartGroup><Bar>ClusterOverlap=0,ClusterWidth=50</Bar" +
				"><ShowOutline>True</ShowOutline><Polar>Degrees=True,PiRatioAnnotations=True,Star" +
				"t=0</Polar><Radar>Degrees=True,Filled=False,Start=0</Radar><Pie>OtherOffset=0,St" +
				"art=0</Pie><Name>Group1</Name><ChartType>XYPlot</ChartType><Stacked>False</Stack" +
				"ed><Bubble>EncodingMethod=Diameter,MaximumSize=20,MinimumSize=5</Bubble><HiLoDat" +
				"a>FillFalling=True,FillTransparent=True,FullWidth=False,ShowClose=True,ShowOpen=" +
				"True</HiLoData><DataSerializer DefaultSet=\"True\"><DataSeriesCollection><DataSeri" +
				"esSerializer><Y3 /><Y2 /><Y>20;22;19;24;25</Y><LineStyle Thickness=\"1\" Color=\"Da" +
				"rkGoldenrod\" Pattern=\"Solid\" /><SymbolStyle Shape=\"Box\" Color=\"Coral\" /><SeriesL" +
				"abel>series 0</SeriesLabel><DataTypes>Single;Single;Single;Single;Single</DataTy" +
				"pes><Y1 /><X>1;2;3;4;5</X></DataSeriesSerializer><DataSeriesSerializer><Y3 /><Y2" +
				" /><Y>8;12;10;12;15</Y><LineStyle Thickness=\"1\" Color=\"DarkGray\" Pattern=\"Solid\"" +
				" /><SymbolStyle Shape=\"Dot\" Color=\"CornflowerBlue\" /><SeriesLabel>series 1</Seri" +
				"esLabel><DataTypes>Single;Single;Single;Single;Single</DataTypes><Y1 /><X>1;2;3;" +
				"4;5</X></DataSeriesSerializer><DataSeriesSerializer><Y3 /><Y2 /><Y>10;16;17;15;2" +
				"3</Y><LineStyle Thickness=\"1\" Color=\"DarkGreen\" Pattern=\"Solid\" /><SymbolStyle S" +
				"hape=\"Tri\" Color=\"Cornsilk\" /><SeriesLabel>series 2</SeriesLabel><DataTypes>Sing" +
				"le;Single;Single;Single;Single</DataTypes><Y1 /><X>1;2;3;4;5</X></DataSeriesSeri" +
				"alizer><DataSeriesSerializer><Y3 /><Y2 /><Y>16;19;15;22;18</Y><LineStyle Thickne" +
				"ss=\"1\" Color=\"DarkKhaki\" Pattern=\"Solid\" /><SymbolStyle Shape=\"Diamond\" Color=\"C" +
				"rimson\" /><SeriesLabel>series 3</SeriesLabel><DataTypes>Single;Single;Single;Sin" +
				"gle;Single</DataTypes><Y1 /><X>1;2;3;4;5</X></DataSeriesSerializer></DataSeriesC" +
				"ollection></DataSerializer></ChartGroup><ChartGroup><Bar>ClusterOverlap=0,Cluste" +
				"rWidth=50</Bar><ShowOutline>True</ShowOutline><Polar>Degrees=True,PiRatioAnnotat" +
				"ions=True,Start=0</Polar><Radar>Degrees=True,Filled=False,Start=0</Radar><Pie>Ot" +
				"herOffset=0,Start=0</Pie><Name>Group2</Name><ChartType>XYPlot</ChartType><Stacke" +
				"d>False</Stacked><Bubble>EncodingMethod=Diameter,MaximumSize=20,MinimumSize=5</B" +
				"ubble><HiLoData>FillFalling=True,FillTransparent=True,FullWidth=False,ShowClose=" +
				"True,ShowOpen=True</HiLoData><DataSerializer /></ChartGroup></ChartGroupsCollect" +
				"ion></Chart2DPropBag>";
			this.c1Chart1.Size = new System.Drawing.Size(488, 403);
			this.c1Chart1.TabIndex = 6;
			// 
			// panel3
			// 
			this.panel3.Controls.AddRange(new System.Windows.Forms.Control[] {
																																				 this.groupBox2,
																																				 this.groupBox1});
			this.panel3.Dock = System.Windows.Forms.DockStyle.Left;
			this.panel3.Name = "panel3";
			this.panel3.Size = new System.Drawing.Size(104, 403);
			this.panel3.TabIndex = 0;
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.AddRange(new System.Windows.Forms.Control[] {
																																						this.chkESeries3,
																																						this.chkESeries1,
																																						this.chkESeries2,
																																						this.chkESeries0});
			this.groupBox2.Dock = System.Windows.Forms.DockStyle.Top;
			this.groupBox2.Location = new System.Drawing.Point(0, 128);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(104, 128);
			this.groupBox2.TabIndex = 4;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Exclude";
			// 
			// chkESeries3
			// 
			this.chkESeries3.Location = new System.Drawing.Point(16, 96);
			this.chkESeries3.Name = "chkESeries3";
			this.chkESeries3.Size = new System.Drawing.Size(80, 24);
			this.chkESeries3.TabIndex = 7;
			this.chkESeries3.Text = "Series 3";
			this.chkESeries3.CheckedChanged += new System.EventHandler(this.chkESeries3_CheckedChanged);
			// 
			// chkESeries1
			// 
			this.chkESeries1.Location = new System.Drawing.Point(16, 48);
			this.chkESeries1.Name = "chkESeries1";
			this.chkESeries1.Size = new System.Drawing.Size(80, 24);
			this.chkESeries1.TabIndex = 6;
			this.chkESeries1.Text = "Series 1";
			this.chkESeries1.CheckedChanged += new System.EventHandler(this.chkESeries1_CheckedChanged);
			// 
			// chkESeries2
			// 
			this.chkESeries2.Location = new System.Drawing.Point(16, 72);
			this.chkESeries2.Name = "chkESeries2";
			this.chkESeries2.Size = new System.Drawing.Size(80, 24);
			this.chkESeries2.TabIndex = 5;
			this.chkESeries2.Text = "Series 2";
			this.chkESeries2.CheckedChanged += new System.EventHandler(this.chkESeries2_CheckedChanged);
			// 
			// chkESeries0
			// 
			this.chkESeries0.Location = new System.Drawing.Point(16, 24);
			this.chkESeries0.Name = "chkESeries0";
			this.chkESeries0.Size = new System.Drawing.Size(80, 24);
			this.chkESeries0.TabIndex = 4;
			this.chkESeries0.Text = "Series 0";
			this.chkESeries0.CheckedChanged += new System.EventHandler(this.chkESeries0_CheckedChanged);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																																						this.chkHSeries3,
																																						this.chkHSeries1,
																																						this.chkHSeries2,
																																						this.chkHSeries0});
			this.groupBox1.Dock = System.Windows.Forms.DockStyle.Top;
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(104, 128);
			this.groupBox1.TabIndex = 3;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Hide";
			// 
			// chkHSeries3
			// 
			this.chkHSeries3.Location = new System.Drawing.Point(16, 96);
			this.chkHSeries3.Name = "chkHSeries3";
			this.chkHSeries3.Size = new System.Drawing.Size(80, 24);
			this.chkHSeries3.TabIndex = 7;
			this.chkHSeries3.Text = "Series 3";
			this.chkHSeries3.CheckedChanged += new System.EventHandler(this.chkHSeries3_CheckedChanged);
			// 
			// chkHSeries1
			// 
			this.chkHSeries1.Location = new System.Drawing.Point(16, 48);
			this.chkHSeries1.Name = "chkHSeries1";
			this.chkHSeries1.Size = new System.Drawing.Size(80, 24);
			this.chkHSeries1.TabIndex = 6;
			this.chkHSeries1.Text = "Series 1";
			this.chkHSeries1.CheckedChanged += new System.EventHandler(this.chkHSeries1_CheckedChanged);
			// 
			// chkHSeries2
			// 
			this.chkHSeries2.Location = new System.Drawing.Point(16, 72);
			this.chkHSeries2.Name = "chkHSeries2";
			this.chkHSeries2.Size = new System.Drawing.Size(80, 24);
			this.chkHSeries2.TabIndex = 5;
			this.chkHSeries2.Text = "Series 2";
			this.chkHSeries2.CheckedChanged += new System.EventHandler(this.chkHSeries2_CheckedChanged);
			// 
			// chkHSeries0
			// 
			this.chkHSeries0.Location = new System.Drawing.Point(16, 24);
			this.chkHSeries0.Name = "chkHSeries0";
			this.chkHSeries0.Size = new System.Drawing.Size(80, 24);
			this.chkHSeries0.TabIndex = 4;
			this.chkHSeries0.Text = "Series 0";
			this.chkHSeries0.CheckedChanged += new System.EventHandler(this.chkHSeries0_CheckedChanged);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 403);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.panel2});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu1;
			this.MinimizeBox = false;
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "ComponentOne Chart for .NET 2D - Floating Stacked Bars Demo";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.panel2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.c1Chart1)).EndInit();
			this.panel3.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>


		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			setupChart();
		}

		private void chkHSeries0_CheckedChanged(object sender, System.EventArgs e)
		{
			if(chkHSeries0.Checked)
				c1Chart1.ChartGroups[0].ChartData.SeriesList[0].Display = C1.Win.C1Chart.SeriesDisplayEnum.Hide;
			else
				c1Chart1.ChartGroups[0].ChartData.SeriesList[0].Display = C1.Win.C1Chart.SeriesDisplayEnum.Show;
		}

		private void chkHSeries1_CheckedChanged(object sender, System.EventArgs e)
		{
			if(chkHSeries1.Checked)
				c1Chart1.ChartGroups[0].ChartData.SeriesList[1].Display = C1.Win.C1Chart.SeriesDisplayEnum.Hide;
			else
				c1Chart1.ChartGroups[0].ChartData.SeriesList[1].Display = C1.Win.C1Chart.SeriesDisplayEnum.Show;
		}

		private void chkHSeries2_CheckedChanged(object sender, System.EventArgs e)
		{
			if(chkHSeries2.Checked)
				c1Chart1.ChartGroups[0].ChartData.SeriesList[2].Display = C1.Win.C1Chart.SeriesDisplayEnum.Hide;
			else
				c1Chart1.ChartGroups[0].ChartData.SeriesList[2].Display = C1.Win.C1Chart.SeriesDisplayEnum.Show;
		}

		private void chkHSeries3_CheckedChanged(object sender, System.EventArgs e)
		{
			if(chkHSeries3.Checked)
				c1Chart1.ChartGroups[0].ChartData.SeriesList[3].Display = C1.Win.C1Chart.SeriesDisplayEnum.Hide;
			else
				c1Chart1.ChartGroups[0].ChartData.SeriesList[3].Display = C1.Win.C1Chart.SeriesDisplayEnum.Show;
		}

		private void chkESeries0_CheckedChanged(object sender, System.EventArgs e)
		{
			if(chkESeries0.Checked)
				c1Chart1.ChartGroups[0].ChartData.SeriesList[0].Display = C1.Win.C1Chart.SeriesDisplayEnum.Exclude;
			else
				c1Chart1.ChartGroups[0].ChartData.SeriesList[0].Display = C1.Win.C1Chart.SeriesDisplayEnum.Show;
		}

		private void chkESeries1_CheckedChanged(object sender, System.EventArgs e)
		{
			if(chkESeries1.Checked)
				c1Chart1.ChartGroups[0].ChartData.SeriesList[1].Display = C1.Win.C1Chart.SeriesDisplayEnum.Exclude;
			else
				c1Chart1.ChartGroups[0].ChartData.SeriesList[1].Display = C1.Win.C1Chart.SeriesDisplayEnum.Show;
		}

		private void chkESeries2_CheckedChanged(object sender, System.EventArgs e)
		{
			if(chkESeries2.Checked)
				c1Chart1.ChartGroups[0].ChartData.SeriesList[2].Display = C1.Win.C1Chart.SeriesDisplayEnum.Exclude;
			else
				c1Chart1.ChartGroups[0].ChartData.SeriesList[2].Display = C1.Win.C1Chart.SeriesDisplayEnum.Show;
		}

		private void chkESeries3_CheckedChanged(object sender, System.EventArgs e)
		{
			if(chkESeries3.Checked)
				c1Chart1.ChartGroups[0].ChartData.SeriesList[3].Display = C1.Win.C1Chart.SeriesDisplayEnum.Exclude;
			else
				c1Chart1.ChartGroups[0].ChartData.SeriesList[3].Display = C1.Win.C1Chart.SeriesDisplayEnum.Show;
		}

		private void menuFileExit_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void menuHelpAbout_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show( this, Text, "About", MessageBoxButtons.OK, MessageBoxIcon.Information);
		}
	}
}
